## avogadrolibs 1.95.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

project(AvogadroLibs)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Request C++11 standard when building Python wheels due to old compiler/glibc.
# Use C++17 otherwise, and hopefully globally once the pip infra is updated.
option(PYTHON_WHEEL_BUILD "Is this a Python wheel build?" OFF)
mark_as_advanced(PYTHON_WHEEL_BUILD)
if(PYTHON_WHEEL_BUILD)
  set(CMAKE_CXX_STANDARD 11)
else()
  set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_EXTENSIONS False)
# Set symbol visibility defaults for all targets.
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN True)

include(BuildType)
include(BuildLocation)
include(CompilerFlags)
include(InstallLocation)
include(DetermineVersion)

# Set up our version.
set(AvogadroLibs_VERSION_MAJOR   "1")
set(AvogadroLibs_VERSION_MINOR   "95")
set(AvogadroLibs_VERSION_PATCH   "1")
set(AvogadroLibs_VERSION
  "${AvogadroLibs_VERSION_MAJOR}.${AvogadroLibs_VERSION_MINOR}.${AvogadroLibs_VERSION_PATCH}")
find_package(Git)
determine_version(${AvogadroLibs_SOURCE_DIR} ${GIT_EXECUTABLE} "AvogadroLibs")

option(BUILD_SHARED_LIBS "Build with shared libraries" ON)

# Before any plugins are defined, and before any add_subdirectory calls:
set_property(GLOBAL PROPERTY AvogadroLibs_PLUGINS)
set_property(GLOBAL PROPERTY AvogadroLibs_STATIC_PLUGINS)

if(MSVC)
  add_definitions("-D_CRT_SECURE_NO_WARNINGS" "-DNOMINMAX -D_USE_MATH_DEFINES")
endif()

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR})

option(ENABLE_TESTING "Enable testing and building the tests." OFF)
option(TEST_QTGL "Build the Qt OpenGL test application" OFF)
option(ENABLE_TRANSLATIONS "Enable building translations with Qt5 Linguist" OFF)
option(USE_OPENGL "Enable libraries that use OpenGL" ON)
option(USE_HDF5 "Enable optional HDF5 features" OFF)
option(USE_QT "Enable libraries that use Qt 5" ON)
option(USE_VTK "Enable libraries that use VTK" OFF)
option(USE_LIBARCHIVE "Enable optional Libarchive features" ON)
option(USE_LIBMSYM "Enable optional features using libmsym" ON)
option(USE_SPGLIB "Enable optional features using spglib" ON)
option(USE_MMTF "Enable optional features using mmtf" ON)
option(USE_PROTOCALL "Enable libraries that use ProtoCall" OFF)
option(USE_PYTHON "Use Python to wrap some of our API" OFF)

add_subdirectory(utilities)
add_subdirectory(thirdparty)
add_subdirectory(avogadro)

if(ENABLE_TESTING)
  include(CTest)
  enable_testing()
  add_subdirectory(tests)
endif()

option(BUILD_DOCUMENTATION "Build project documentation" OFF)

if(BUILD_DOCUMENTATION)
  add_subdirectory(docs)
endif()

if(USE_PYTHON)
  add_subdirectory(python)
endif()

if(ENABLE_TRANSLATIONS)
  find_package(Qt5LinguistTools)
endif()

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(
    FILES
      README.md
      CONTRIBUTING.md
      LICENSE
    DESTINATION "${INSTALL_DOC_DIR}/avogadrolibs")
endif()

# After all add_subdirectory calls, so the list of plugins is complete:
get_property(AvogadroLibs_PLUGINS GLOBAL PROPERTY AvogadroLibs_PLUGINS)
get_property(AvogadroLibs_STATIC_PLUGINS GLOBAL
  PROPERTY AvogadroLibs_STATIC_PLUGINS)

configure_file(${AvogadroLibs_SOURCE_DIR}/cmake/CTestCustom.cmake.in
  ${AvogadroLibs_BINARY_DIR}/CTestCustom.cmake)

configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfig.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake" @ONLY)
configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfigVersion.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake" @ONLY)

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(FILES
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake"
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindEigen3.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindGLEW.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindLibArchive.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Findlibmsym.cmake"
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
  install(EXPORT "AvogadroLibsTargets"
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
endif()

=== avogadro/CMakeLists.txt ===
include(GenerateExportHeader)

function(avogadro_add_library name)
  add_library(${name} ${ARGN})
  # Use the new AUTOMOC support for Qt libraries (CMake 2.8.6).
  if(${name} MATCHES "^AvogadroQt")
    set_target_properties(${name} PROPERTIES AUTOMOC TRUE)
  endif()
  if(BUILD_SHARED_LIBS)
  set_target_properties(${name} PROPERTIES VERSION "${AvogadroLibs_VERSION_MAJOR}.${AvogadroLibs_VERSION_MINOR}.${AvogadroLibs_VERSION_PATCH}"
   					   SOVERSION ${AvogadroLibs_VERSION_MAJOR})
  endif()
  string(TOLOWER ${name} lowerName)
  # Generate the necessary export headers.
  generate_export_header(${name} EXPORT_FILE_NAME ${lowerName}export.h)
  list(APPEND HEADERS "${CMAKE_CURRENT_BINARY_DIR}/${lowerName}export.h")
  include_directories(${CMAKE_CURRENT_BINARY_DIR})
  # Now install everything.
  string(REGEX REPLACE "^avogadro" "" module ${lowerName})

  # SKBUILD is set for binary wheel
  if (NOT SKBUILD)
    install(FILES ${HEADERS}
      DESTINATION "${INSTALL_INCLUDE_DIR}/avogadro/${module}")
  else()
    # For MACOSX
    set_target_properties(${name} PROPERTIES INSTALL_NAME_DIR "@rpath")
    set(INSTALL_RUNTIME_DIR avogadro)
    set(INSTALL_LIBRARY_DIR avogadro)
    set(INSTALL_ARCHIVE_DIR avogadro)
  endif()

  install(TARGETS ${name}
    EXPORT "AvogadroLibsTargets"
    RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIBRARY_DIR}"
    ARCHIVE DESTINATION "${INSTALL_ARCHIVE_DIR}")
endfunction()

add_subdirectory(core)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/core)

add_subdirectory(io)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/io)
add_subdirectory(quantumio)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/quantumio)
# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  add_subdirectory(command)
endif()
if(USE_OPENGL)
  add_subdirectory(rendering)
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/rendering)
endif()

if(USE_QT)
  add_subdirectory(qtgui)
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/qtgui)
  if(USE_OPENGL)
    add_subdirectory(qtopengl)
    include_directories(${CMAKE_CURRENT_BINARY_DIR}/qtopengl)
  endif()
  # Add unconditionally as this talks to MoleQueue, but doesn't depend on it.
  add_subdirectory(molequeue)
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/molequeue)
  if(USE_VTK)
    add_subdirectory(vtk)
    include_directories(${CMAKE_CURRENT_BINARY_DIR}/vtk)
  endif()
  add_subdirectory(qtplugins)
endif()

if(USE_PROTOCALL)
  add_subdirectory(protocall)
endif()

=== avogadro/command/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
include_directories(SYSTEM "${EIGEN3_INCLUDE_DIR}")

add_executable(avocjsontocml cjsontocml.cpp)
target_link_libraries(avocjsontocml AvogadroIO)

add_executable(avobabel avobabel.cpp)
target_link_libraries(avobabel AvogadroIO)

add_executable(qube qube.cpp)
target_link_libraries(qube AvogadroQuantumIO AvogadroIO)

=== avogadro/core/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
# Add as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM ${EIGEN3_INCLUDE_DIR})

if(USE_SPGLIB)
  find_package(Spglib REQUIRED)
  include_directories(SYSTEM ${SPGLIB_INCLUDE_DIR})
endif()

# configure the version header
configure_file("${PROJECT_SOURCE_DIR}/cmake/version.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/version.h")

set(HEADERS
  angletools.h
  angleiterator.h
  array.h
  atom.h
  atomtyper.h
  atomtyper-inline.h
  avogadrocore.h
  basisset.h
  connectedgroup.h
  bond.h
  color3f.h
  coordinateset.h
  coordinateblockgenerator.h
  crystaltools.h
  cube.h
  dihedraliterator.h
  elements.h
  gaussianset.h
  gaussiansettools.h
  graph.h
  layer.h
  layermanager.h
  matrix.h
  mesh.h
  molecule.h
  mutex.h
  nameatomtyper.h
  residue.h
  ringperceiver.h
  secondarystructure.h
  slaterset.h
  slatersettools.h
  spacegroups.h
  symbolatomtyper.h
  types.h
  unitcell.h
  utilities.h
  variant.h
  variant-inline.h
  variantmap.h
  vector.h
  "${CMAKE_CURRENT_BINARY_DIR}/version.h"
)

set(SOURCES
  angleiterator.cpp
  connectedgroup.cpp
  coordinateblockgenerator.cpp
  crystaltools.cpp
  cube.cpp
  elements.cpp
  dihedraliterator.cpp
  gaussianset.cpp
  gaussiansettools.cpp
  graph.cpp
  layer.cpp
  layermanager.cpp
  mesh.cpp
  mdlvalence_p.h
  molecule.cpp
  mutex.cpp
  nameatomtyper.cpp
  residue.cpp
  ringperceiver.cpp
  secondarystructure.cpp
  slaterset.cpp
  slatersettools.cpp
  spacegroups.cpp
  symbolatomtyper.cpp
  unitcell.cpp
  variantmap.cpp
  version.cpp
)

# We currently build core without shared_mutex for Python wheels.
if(NOT PYTHON_WHEEL_BUILD)
  list(APPEND HEADERS sharedmutex.h)
  list(APPEND SOURCES sharedmutex.cpp)
endif()

if(USE_SPGLIB)
  list(APPEND HEADERS avospglib.h)
  list(APPEND SOURCES avospglib.cpp)
endif()

# The std::shared_mutex class needs pthreads on Linux.
if(UNIX AND NOT APPLE AND NOT PYTHON_WHEEL_BUILD)
  find_package(Threads)
  set(EXTRA_LINK_LIB ${CMAKE_THREAD_LIBS_INIT})
else()
  set(EXTRA_LINK_LIB "")
endif()

avogadro_add_library(AvogadroCore ${HEADERS} ${SOURCES})
target_link_libraries(AvogadroCore
  PRIVATE ${SPGLIB_LIBRARY} ${EXTRA_LINK_LIB})

=== avogadro/io/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)

if(USE_MMTF)
  find_package(MMTF REQUIRED)
  include_directories(SYSTEM "${MMTF_INCLUDE_DIRS}")
  add_definitions(-DAVO_USE_MMTF)
endif()

if(USE_HDF5)
  find_package(HDF5 REQUIRED COMPONENTS C)
  # HDF5 is built in two ways (CMake or its default build system). If we are
  # using the CMake version it makes use of exported targets, hence this check.
  if(NOT DEFINED HDF5_LIBRARIES)
    set(HDF5_LIBRARIES "hdf5")
  endif()
  include_directories(SYSTEM "${HDF5_INCLUDE_DIRS}")
  add_definitions(-DAVO_USE_HDF5 -DH5_USE_110_API)
endif()

# Add as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM "${EIGEN3_INCLUDE_DIR}"
  "${AvogadroLibs_SOURCE_DIR}/thirdparty/pugixml"
  "${AvogadroLibs_SOURCE_DIR}/thirdparty/struct"
  "${AvogadroLibs_SOURCE_DIR}/thirdparty")

if(DEFINED AvogadroLibs_MEMORY_INCLUDE_DIRS)
  # The smart pointer classes just require headers.
  include_directories(SYSTEM ${AvogadroLibs_MEMORY_INCLUDE_DIRS})
endif()

set(HEADERS
  cjsonformat.h
  cmlformat.h
  dcdformat.h
  fileformat.h
  fileformatmanager.h
  gromacsformat.h
  mdlformat.h
  vaspformat.h
  pdbformat.h
  xyzformat.h
  trrformat.h
  lammpsformat.h
)

set(SOURCES
  cjsonformat.cpp
  cmlformat.cpp
  dcdformat.cpp
  fileformat.cpp
  fileformatmanager.cpp
  gromacsformat.cpp
  mdlformat.cpp
  vaspformat.cpp
  pdbformat.cpp
  xyzformat.cpp
  trrformat.cpp
  lammpsformat.cpp
)

if(USE_HDF5)
  list(APPEND HEADERS hdf5dataformat.h)
  list(APPEND SOURCES hdf5dataformat.cpp)
endif()

if(USE_MMTF)
  list(APPEND HEADERS mmtfformat.h)
  list(APPEND SOURCES mmtfformat.cpp)
endif()

avogadro_add_library(AvogadroIO ${HEADERS} ${SOURCES})

target_link_libraries(AvogadroIO
  PUBLIC AvogadroCore
  PRIVATE struct)
if(USE_HDF5)
  target_link_libraries(AvogadroIO PRIVATE ${HDF5_LIBRARIES})
endif()
if(WIN32)
  target_link_libraries(AvogadroIO PRIVATE ws2_32)
endif()

=== avogadro/qtgui/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
# Add as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM ${EIGEN3_INCLUDE_DIR})

find_package(Qt5 COMPONENTS Widgets REQUIRED)

# Provide some simple API to find the plugins, scripts, etc.
if(APPLE)
  # It is a special case, the app bundle logic breaks the relative pathing.
  add_definitions(-DAvogadroLibs_LIB_DIR=\"lib\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"share\")
else()
  add_definitions(-DAvogadroLibs_LIB_DIR=\"${INSTALL_LIBRARY_DIR}\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"${INSTALL_DATA_DIR}\")
endif()

if(USE_SPGLIB)
  add_definitions(-DUSE_SPGLIB)
endif()

# Find python for input generator scripts:
find_package(PythonInterp 3)

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
"namespace Avogadro {
static const char *pythonInterpreterPath = \"${PYTHON_EXECUTABLE}\";
}
")
configure_file("${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h")

set(HEADERS
  backgroundfileformat.h
  colorbutton.h
  containerwidget.h
  customelementdialog.h
  elementtranslator.h
  extensionplugin.h
  filebrowsewidget.h
  fileformatdialog.h
  generichighlighter.h
  hydrogentools.h
  interfacescript.h
  interfacewidget.h
  jsonwidget.h
  layermodel.h
  rwlayermanager.h
  meshgenerator.h
  molecule.h
  moleculemodel.h
  multiviewwidget.h
  periodictableview.h
  persistentatom.h
  persistentbond.h
  pluginlayermanager.h
  pythonscript.h
  rwmolecule.h
  sceneplugin.h
  scenepluginmodel.h
  scriptloader.h
  toolplugin.h
  utilities.h
  viewfactory.h
)

set(SOURCES
  backgroundfileformat.cpp
  colorbutton.cpp
  containerwidget.cpp
  customelementdialog.cpp
  elementdetail_p.cpp
  elementitem_p.cpp
  elementtranslator.cpp
  extensionplugin.cpp
  filebrowsewidget.cpp
  fileformatdialog.cpp
  generichighlighter.cpp
  hydrogentools.cpp
  interfacescript.cpp
  interfacewidget.cpp
  jsonwidget.cpp
  layermodel.cpp
  rwlayermanager.cpp
  meshgenerator.cpp
  molecule.cpp
  moleculemodel.cpp
  multiviewwidget.cpp
  periodictablescene_p.cpp
  periodictableview.cpp
  pluginlayermanager.cpp
  pythonscript.cpp
  rwmolecule.cpp
  sceneplugin.cpp
  scenepluginmodel.cpp
  scriptloader.cpp
  toolplugin.cpp
  utilities.cpp
  viewfactory.cpp
)

set(UIS
  customelementdialog.ui
)
qt5_wrap_ui(UI_SOURCES ${UIS})
list(APPEND SOURCES ${UI_SOURCES})

set(RCS
  qtgui.qrc
)
qt5_add_resources(RC_SOURCES ${RCS})
list(APPEND SOURCES ${RC_SOURCES})

avogadro_add_library(AvogadroQtGui ${HEADERS} ${SOURCES})
target_link_libraries(AvogadroQtGui AvogadroIO Qt5::Widgets)

=== avogadro/qtplugins/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
include_directories(SYSTEM ${EIGEN3_INCLUDE_DIR})

find_package(Qt5 COMPONENTS Widgets Network Concurrent REQUIRED)
include_directories(SYSTEM ${Qt5Widgets_INCLUDE_DIRS})
add_definitions(${Qt5Widgets_DEFINITIONS})

# Modify the output directory for the build tree.
set(original_library_output_dir "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
  "${original_library_output_dir}/avogadro2/plugins")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  "${original_library_output_dir}/avogadro2/staticplugins")

# Optionally build all plugins statically.
option(BUILD_STATIC_PLUGINS "Build static plugins by default" ON)

# Allow GPL plugins to be disabled.
option(BUILD_GPL_PLUGINS
  "Build plugins that are licensed under the GNU Public License." OFF)

# Create a plugin for Avogadro.
# name is the name of the plugin, this will be the name of the target created.
# description Free text description of the plugin.
# type The base class of the plugin.
# header is the header(s) for the class to be instantiated for the plugin.
# pluginClass is the class to be instantiated for the plugin.
# sources is the list of source files for the plugin.
# uis is the list of UI files that need to be compiled (optional).
# rcs is the list of qrc files that need to be compiled (optional).
function(avogadro_plugin name description type header pluginClass sources)
  set(uis "")
  set(rcs "")
  if(${ARGC} GREATER 6)
    set(uis ${ARGV6})
  endif()
  if(${ARGC} GREATER 7)
    set(rcs ${ARGV7})
  endif()
  qt5_wrap_ui(ui_srcs ${uis})
  qt5_add_resources(rc_srcs ${rcs})
  include_directories(${CMAKE_CURRENT_BINARY_DIR})
  unset(PluginIncludes)
  foreach(_header ${header})
    set(PluginIncludes
      "${PluginIncludes}#include \"${CMAKE_CURRENT_SOURCE_DIR}/${_header}\"\n")
  endforeach()
  set(PluginName "${name}")
  set(PluginDescription "${description}")
  set(PluginType "${type}")
  set(PluginClass "${pluginClass}")
  configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/avogadroplugin.cpp.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${name}Plugin.cpp")

  # Figure out which type of plugin is being added, and put it in the right list
  if(BUILD_STATIC_PLUGINS)
    set(_plugin_object "STATIC")
    set_property(GLOBAL APPEND PROPERTY AvogadroLibs_STATIC_PLUGINS ${name})
    if(rcs)
      get_filename_component(_name_we ${rcs} NAME_WE)
      set_property(GLOBAL APPEND PROPERTY AvogadroLibs_STATIC_RCS ${_name_we})
    endif()
  else()
    set(_plugin_object "MODULE")
    set_property(GLOBAL APPEND PROPERTY AvogadroLibs_PLUGINS ${name})
  endif()

  add_library(${name}
    ${_plugin_object}
    ${sources}
    ${ui_srcs}
    ${rc_srcs}
    ${name}Plugin.cpp
  )
  target_link_libraries(${name} PRIVATE AvogadroCore AvogadroQtGui)

  if("${_plugin_object}" STREQUAL "STATIC")
    set_target_properties(${name} PROPERTIES COMPILE_DEFINITIONS
      "QT_STATICPLUGIN")
    if(UNIX) # Need -fPIC for static plugins linked to shared libs on Unix.
      set_target_properties(${name} PROPERTIES COMPILE_FLAGS "-fPIC")
    endif()
  endif()

  set_target_properties(${name} PROPERTIES AUTOMOC TRUE PREFIX "")
  install(TARGETS ${name}
    EXPORT "AvogadroLibsTargets"
    RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIBRARY_DIR}/avogadro2/plugins"
    ARCHIVE DESTINATION "${INSTALL_ARCHIVE_DIR}/avogadro2/staticplugins")
endfunction()

# Now to make the plugins.
add_subdirectory(3dmol)
add_subdirectory(applycolors)
add_subdirectory(bondcentrictool)
add_subdirectory(bonding)
add_subdirectory(cartoons)
add_subdirectory(commandscripts)
add_subdirectory(coordinateeditor)
add_subdirectory(copypaste)
add_subdirectory(crystal)
add_subdirectory(customelements)
add_subdirectory(editor)
add_subdirectory(fetchpdb)
add_subdirectory(hydrogens)
add_subdirectory(importpqr)
add_subdirectory(insertfragment)
add_subdirectory(label)
add_subdirectory(lammpsinput)
add_subdirectory(lineformatinput)
add_subdirectory(manipulator)
add_subdirectory(measuretool)
add_subdirectory(molecularproperties)
add_subdirectory(mongochem)
add_subdirectory(navigator)
add_subdirectory(networkdatabases)
add_subdirectory(openbabel)
add_subdirectory(openmminput)
add_subdirectory(playertool)
add_subdirectory(propertytables)
add_subdirectory(povray)
add_subdirectory(resetview)
add_subdirectory(select)
add_subdirectory(selectiontool)
if(USE_SPGLIB)
  add_subdirectory(spacegroup)
endif()
add_subdirectory(surfaces)
add_subdirectory(svg)
add_subdirectory(spectra)
add_subdirectory(vrml)

# Plugins that require VTK
if(USE_VTK)
  add_subdirectory(plotpdf)
  add_subdirectory(plotrmsd)
  add_subdirectory(plotxrd)
  if(BUILD_YAEHMOP_PLUGIN)
    add_subdirectory(yaehmop)
  endif()
  add_subdirectory(coloropacitymap)
endif()

add_subdirectory(apbs)
add_subdirectory(cp2kinput)
add_subdirectory(gamessinput)
add_subdirectory(quantuminput)
add_subdirectory(scriptfileformats)

if(USE_LIBARCHIVE)
  add_subdirectory(plugindownloader)
endif()

if(USE_LIBMSYM)
  add_subdirectory(symmetry)
endif()

# The scene plugins
add_subdirectory(ballandstick)
add_subdirectory(licorice)
add_subdirectory(vanderwaals)
add_subdirectory(wireframe)
add_subdirectory(force)
add_subdirectory(meshes)
add_subdirectory(overlayaxes)
add_subdirectory(vanderwaalsao)
if (USE_PROTOCALL)
  add_subdirectory(clientserver)
endif()

if(BUILD_GPL_PLUGINS)
  # qtaimcurvature.h/cpp contains GPL licensed code:
  add_subdirectory(qtaim)
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${original_library_output_dir}")

# Add all of the static plugins to the initialization file.
get_property(AvogadroLibs_STATIC_PLUGINS GLOBAL
  PROPERTY AvogadroLibs_STATIC_PLUGINS)
get_property(AvogadroLibs_STATIC_RCS GLOBAL
  PROPERTY AvogadroLibs_STATIC_RCS)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "// Automatically generated file. Do not edit.
#ifndef AVOGADRO_STATIC_QTPLUGINS_H
#define AVOGADRO_STATIC_QTPLUGINS_H

#include <QtCore/QtPlugin>\n\n")

foreach(_plugin ${AvogadroLibs_STATIC_PLUGINS})
  file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
    "Q_IMPORT_PLUGIN(${_plugin}Factory)\n")
endforeach()
file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "\nvoid initAvogadroPluginResources() {\n")
foreach(_rcs ${AvogadroLibs_STATIC_RCS})
  file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
    "  Q_INIT_RESOURCE(${_rcs});\n")
endforeach()
file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "}\n\n")

file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "\n#endif // AVOGADRO_STATIC_QTPLUGINS_H\n")

# Configure the static plugin header, ensuring it only changes if the contents
# are modified - otherwise the original timestamp will be maintained.
configure_file("${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h")

# Now to build the plugin library, which can also statically link plugins
# and initialize them for the application. If Avogadro is built statically
# then the static plugin header must be included by the application.
set(HEADERS
  pluginmanager.h
  pluginfactory.h
  "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h"
)

set(SOURCES
  pluginmanager.cpp
)

avogadro_add_library(AvogadroQtPlugins ${HEADERS} ${SOURCES})
target_link_libraries(AvogadroQtPlugins PUBLIC ${Qt5Core_LIBRARIES}
  PRIVATE ${AvogadroLibs_STATIC_PLUGINS} AvogadroQtGui)

=== avogadro/quantumio/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
# Add as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM "${EIGEN3_INCLUDE_DIR}"
  "${AvogadroLibs_SOURCE_DIR}/thirdparty")

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Headers for our public API
set(HEADERS
  gamessus.h
  gaussianfchk.h
  gaussiancube.h
  molden.h
  mopacaux.h
  nwchemjson.h
  nwchemlog.h
)

# Source files for our data.
set(SOURCES
  #gamessukout.cpp
  gamessus.cpp
  gaussianfchk.cpp
  gaussiancube.cpp
  molden.cpp
  mopacaux.cpp
  nwchemjson.cpp
  nwchemlog.cpp
)

avogadro_add_library(AvogadroQuantumIO ${HEADERS} ${SOURCES})
target_link_libraries(AvogadroQuantumIO PUBLIC AvogadroIO)

=== avogadro/rendering/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)
# Add as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM ${EIGEN3_INCLUDE_DIR})

find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)
include_directories(SYSTEM ${OPENGL_INCLUDE_DIR} ${GLEW_INCLUDE_DIRS})
if(WIN32 AND NOT BUILD_SHARED_LIBS)
  add_definitions(-DGLEW_STATIC)
endif()

set(HEADERS
  arrowgeometry.h
  avogadrogl.h
  avogadrorendering.h
  beziergeometry.h
  bsplinegeometry.h
  bufferobject.h
  camera.h
  cartoongeometry.h
  curvegeometry.h
  cylindergeometry.h
  drawable.h
  geometrynode.h
  geometryvisitor.h
  groupnode.h
  glrenderer.h
  glrendervisitor.h
  linestripgeometry.h
  meshgeometry.h
  node.h
  povrayvisitor.h
  primitive.h
  scene.h
  shader.h
  shaderprogram.h
  spheregeometry.h
  textlabel2d.h
  textlabel3d.h
  textlabelbase.h
  textproperties.h
  textrenderstrategy.h
  texture2d.h
  transformnode.h
  visitor.h
  volumegeometry.h
  vrmlvisitor.h
)

set(SOURCES
  arrowgeometry.cpp
  beziergeometry.cpp
  bufferobject.cpp
  bsplinegeometry.cpp
  cartoongeometry.cpp
  camera.cpp
  curvegeometry.cpp
  cylindergeometry.cpp
  drawable.cpp
  geometrynode.cpp
  geometryvisitor.cpp
  groupnode.cpp
  glrenderer.cpp
  glrendervisitor.cpp
  linestripgeometry.cpp
  meshgeometry.cpp
  node.cpp
  povrayvisitor.cpp
  scene.cpp
  shader.cpp
  shaderprogram.cpp
  spheregeometry.cpp
  textlabel2d.cpp
  textlabel3d.cpp
  textlabelbase.cpp
  textproperties.cpp
  textrenderstrategy.cpp
  texture2d.cpp
  transformnode.cpp
  visitor.cpp
  volumegeometry.cpp
  vrmlvisitor.cpp
  ambientocclusionspheregeometry.cpp
)

set(shader_files
  "arrow_vs.glsl"
  "cylinders_fs.glsl"
  "cylinders_vs.glsl"
  "linestrip_fs.glsl"
  "linestrip_vs.glsl"
  "mesh_fs.glsl"
  "mesh_vs.glsl"
  "spheres_fs.glsl"
  "spheres_vs.glsl"
  "sphere_ao_depth_vs.glsl"
  "sphere_ao_depth_fs.glsl"
  "sphere_ao_bake_vs.glsl"
  "sphere_ao_bake_fs.glsl"
  "sphere_ao_render_vs.glsl"
  "sphere_ao_render_fs.glsl"
  "textlabelbase_fs.glsl"
  "textlabelbase_vs.glsl"
)
foreach(file ${shader_files})
  get_filename_component(file_we ${file} NAME_WE)
  set(src  ${CMAKE_CURRENT_SOURCE_DIR}/${file})
  set(resh ${CMAKE_CURRENT_BINARY_DIR}/${file_we}.h)
  list(APPEND shader_h_files ${resh})
  add_custom_command(
    OUTPUT ${resh}
    DEPENDS ${src} encodefile
    COMMAND encodefile
    ARGS ${src} ${resh} ${file_we}
    COMMENT "Encoding ${src}"
    )
endforeach()

avogadro_add_library(AvogadroRendering ${HEADERS} ${SOURCES} ${shader_h_files})
target_link_libraries(AvogadroRendering
  ${GLEW_LIBRARY}
  ${OPENGL_LIBRARIES})

=== tests/io/CMakeLists.txt ===
# Specify the name of each test (the Test will be appended where needed).
set(tests
  Cjson
  Cml
  FileFormatManager
  Lammps
  Mdl
  Vasp
  Xyz
  )

if(USE_HDF5)
  list(APPEND tests Hdf5)
endif()

if(USE_MMTF)
  list(APPEND tests MMTF)
endif()

include_directories("${CMAKE_CURRENT_BINARY_DIR}"
	"${AvogadroLibs_BINARY_DIR}/avogadro/io")

if(AVOGADRO_DATA_ROOT)
  set(AVOGADRO_DATA ${AVOGADRO_DATA_ROOT})
else()
  message("No data root found, please set to run the tests.")
  return()
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/iotests.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/iotests.h" @ONLY)

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()
message(STATUS "Test source files: ${testSrcs}")

# Add a single executable for all of our tests.
add_executable(AvogadroIOTests ${testSrcs})
target_link_libraries(AvogadroIOTests AvogadroIO
  ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB})

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "Io-${TestName}"
    COMMAND AvogadroIOTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== tests/qtgui/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_BINARY_DIR}"
  "${AvogadroLibs_BINARY_DIR}/avogadro/qtgui"
  "${AvogadroLibs_BINARY_DIR}/avogadro/molequeue"
  "${AvogadroLibs_SOURCE_DIR}/tests/core")

find_package(Qt5 COMPONENTS Widgets Network Test REQUIRED)

# Pull in MoleQueue for QtJson
find_package(MoleQueue REQUIRED NO_MODULE)
include_directories(${MoleQueue_INCLUDE_DIRS})

# Find python interpreter for input generator
find_package(PythonInterp 3)

# Setup config file with data location
if(AVOGADRO_DATA_ROOT)
  set(AVOGADRO_DATA ${AVOGADRO_DATA_ROOT})
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/qtguitests.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/qtguitests.h" @ONLY)

# Specify the name of each test (the Test will be appended where needed).
set(tests
  GenericHighlighter
  HydrogenTools
  # GitHub is showing this as a free() bug
  # TODO: Fix this
  # Molecule
  MoleQueueQueueListModel
  RWMolecule
  )

if(PYTHON_EXECUTABLE AND AVOGADRO_DATA)
  list(APPEND tests
# FIXME: These tests are broken
#    FileBrowseWidget
#    InputGenerator
#    InputGeneratorWidget
  )
endif()

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()

# Add a single executable for all of our tests.
add_executable(AvogadroQtGuiTests ${testSrcs})
target_link_libraries(AvogadroQtGuiTests AvogadroQtGui AvogadroMoleQueue
  MoleQueueClient ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB} Qt5::Widgets Qt5::Test)

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "QtGui-${TestName}"
    COMMAND AvogadroQtGuiTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== utilities/encodefile/CMakeLists.txt ===
add_executable(encodefile encodefile.cxx)

=== debian/changelog ===
avogadrolibs (1.95.1-8) unstable; urgency=medium

  * Team upload.
  * debian/patches/fix_bond_centric_and_manipulator_tool.patch: Add missing
    upstream commit c47d00c to patch, thanks to Aritz Erkiaga.

 -- Michael Banck <mbanck@debian.org>  Sat, 26 Feb 2022 14:15:45 +0100

avogadrolibs (1.95.1-7) unstable; urgency=medium

  * Team upload.
  * debian/patches/fix_bond_centric_and_manipulator_tool.patch: New patch,
    fixes the bond centric and manipulation tools, taken from upstream commits
    15fe8df and 64f62a4 from pull request #825 and thanks to Aritz Erkiaga.
    Closes: #1005006, #1006184.

 -- Michael Banck <mbanck@debian.org>  Fri, 25 Feb 2022 08:07:31 +0100

avogadrolibs (1.95.1-6) unstable; urgency=medium

  * revert Build-Depends: python3:any | ... dh-sequence-python3
    from 1.95.1-1. The lintian error was incorrect, see Bug#995981.
    Build with default python only since build uses cmake not pybuild.
    Closes: #998469.

 -- Drew Parsons <dparsons@debian.org>  Thu, 25 Nov 2021 13:07:01 +0100

avogadrolibs (1.95.1-5) unstable; urgency=medium

  * add molequeue support
    - adds quantum chemical input support (cp2k, gamess)
    - drop debian patch drop_cp2kinput.patch
    - Build-Depends: molequeue, libmolequeue-dev,
      libavogadro2-1 Recommends: molequeue.
      molequeue is used by libAvogadroMoleQueue.so.1 when available,
      avogadrolibs tests use libmolequeue-dev for molequeue cmake scripts
    - debian patch molequeue_system.patch builds against system
      molequeue instead of vendored molequeue client headers.
  * add qtgui tests in debian/tests
    - debian patch fix_test_qtgui.patch fixes linked libraries in
      tests/qtgui

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Oct 2021 22:42:02 +0200

avogadrolibs (1.95.1-4) unstable; urgency=medium

  * debian patch test_mostly_zero.patch tests ">=0" within machine
    precision, i.e. ">=-EPS". Required for i386 to pass
    UnitCellTest.wrapAtomsToUnitCell, see upstream Issue #812.

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 18:32:36 +0200

avogadrolibs (1.95.1-3) unstable; urgency=medium

  * debian patch use_overlayaxes.patch skips the overlayaxes plugin on
    armel,armhf. Qt/GL support is broken on armel,armhf, see Bug#798408
    and the problem is triggered by the overlayaxes plugin.

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Oct 2021 03:01:34 +0200

avogadrolibs (1.95.1-2) unstable; urgency=medium

  * debian patch nolayer_PR806.patch applies upstream PR#806 to fix
    handling molecules with no layers. Intended to fix spglib segfault
    (upstream Issue#752)

 -- Drew Parsons <dparsons@debian.org>  Tue, 05 Oct 2021 11:53:07 +0200

avogadrolibs (1.95.1-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patches
       fix_SMILES_PR661.patch
       fix_transparency_PR656.patch
       insert_crystals_PR658.patch
       insert_crystals_PR659.patch
       read_nonstandard_pdb_PR647.patch
  * Standards-Version: 4.6.0
  * Build-Depends: python3:any | python3-all:any | python3-dev:any |
     python3-all-dev:any | dh-sequence-python3.
    For lintian warning missing-build-dependency-for-dh-addon
  * download libavogadro2-1 Depends to Recommends: python3:any

 -- Drew Parsons <dparsons@debian.org>  Mon, 04 Oct 2021 16:14:46 +0200

=== debian/control ===
Source: avogadrolibs
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libarchive-dev,
               libeigen3-dev (>> 3.3),
               libgl2ps-dev,
               libglew-dev,
               libglvnd-dev,
               libhdf5-dev,
               libjs-mathjax,
               libsymspg-dev,
               molequeue, libmolequeue-dev,
               openbabel,
               pkg-config,
               python3-dev,
               python3-pybind11,
               python3-skbuild,
               python3-wheel,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               qttools5-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debichem-team/avogadrolibs
Vcs-Git: https://salsa.debian.org/debichem-team/avogadrolibs.git
Homepage: http://avogadro.cc/

Package: avogadro-utils
Architecture: any
Section: science
Depends: libavogadro2-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: avogadro (>= 1.90)
Replaces: avogadro (<< 1.90)
Breaks: avogadro (<< 1.90)
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides avogadro utility programs:
   avobabel
   avocjsontocml
   bodrparse
   encodefile
   qube
   resdataparse

Package: libavogadro2-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libavogadro-data, python3:any, python3-cclib
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the shared libraries, plugins and functionality scripts.

Package: libavogadro-dev
Architecture: any
Section: libs
Multi-Arch: same
Depends: libavogadro2-1 (= ${binary:Version}),
         libeigen3-dev,
         libglew-dev,
         libglvnd-dev,
         openbabel,
         ${misc:Depends}
Recommends: molequeue
Description: Molecular Graphics and Modelling System (development files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the development and header files.

Package: libavogadro-data
Architecture: all
Section: libdevel
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Molecular Graphics and Modelling System (data files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides molecule and crystal data for the
 Insert Fragment plugin.

Package: libavogadro-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${misc:Depends}
Suggests: libavogadro-dev, python3-avogadro
Description: Molecular Graphics and Modelling System (lib documentation)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the documentation for libavogadro.

Package: python3-avogadro
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Molecular Graphics and Modelling System (Python 3 module)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the Python 3 module.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

PYTHON3_VERSION     := $(shell py3versions -dv)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so),)
PYTHON3_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so
else
PYTHON3_LIBRARY=/usr/lib/libpython$(PYTHON3_VERSION).so
endif

empty :=
space := $(empty)$(empty)

# Qt/GL support is broken on ARM, see Bug#798408
# The problem is triggered by the overlayaxes plugin
# so skip this plugin on arm.
# arm64 currently builds but that could change in the future
ARCH_NO_GL_LIST := armel armhf
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_GL_LIST)$(space)))
  OVERLAYAXES_CONFIG := -DUSE_OVERLAYAXES=OFF
else
  OVERLAYAXES_CONFIG := -DUSE_OVERLAYAXES=ON
endif


CMAKE_OPTS=-DUSE_HDF5=ON \
	    -DUSE_LIBMSYM=OFF \
	    -DUSE_MMTF=OFF \
	    -DOpenGL_GL_PREFERENCE=GLVND \
	    -DCMAKE_SKIP_RPATH=TRUE \
	    -DUSE_PYTHON=ON \
	    -DENABLE_TRANSLATIONS=ON \
	    $(OVERLAYAXES_CONFIG)

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_configure-indep:
	dh_auto_configure -- -DBUILD_DOCUMENTATION=ON $(CMAKE_OPTS)

override_dh_auto_build-indep:
	cd obj-$(DEB_HOST_GNU_TYPE); make documentation

override_dh_auto_install-arch:
	dh_auto_install -a
	cp -r obj-$(DEB_HOST_GNU_TYPE)/bin debian/tmp/usr

override_dh_auto_install-indep:
	if [ ! -d debian/tmp ]; then mkdir -p debian/tmp; fi
	cp -r obj-$(DEB_HOST_GNU_TYPE)/docs/html debian/tmp

override_dh_install:
	dh_install
	dh_missing --list-missing

override_dh_installdocs-indep:
	dh_installdocs -i
	grep "https://cdn.jsdelivr.net/npm/mathjax@.*/MathJax.js" debian/libavogadro-doc/usr/share/doc/libavogadro-dev/* -r --files-with-matches | xargs sed "s|src=\"https://cdn.jsdelivr.net/npm/mathjax@.*/MathJax.js|src=\"file:///usr/share/javascript/mathjax/MathJax.js|g" -i
